% Funkcja wywietla informacj o atrybucie
%
% infoAttribute(A, n)
%
% A - struktura danych (macierz komrkowa)
% n - numer atrybutu ('all' - informacja dla wszystkich atrybutw)

function [] = infoAttribute(A, n)

if strcmp(n,'all')
    for i=1:size(A{1},2)   
        infoAttribute(A,i);   disp(' '); disp(repmat('-',1,80)); disp(' ');  
    end
    return;
end

nazwa = A{3}{n};
lista = A{2}{n};
d = A{1}(:,n);

if  isempty(lista) % atrybut numeryczny
    s = sprintf('Attribute %d name: %s (numeric)', n, nazwa);
    disp(s); disp(' ');
    
    dd = d;
    dd(isnan(d)) = [];

    s = sprintf('minimum value  -> %g',min(dd));  disp(s);        
    s = sprintf('maximum value  -> %g',max(dd));  disp(s);        
    s = sprintf('mean value  -> %g',mean(dd));  disp(s);
    s = sprintf('standard deviation value  -> %g',std(dd));  disp(s);
    s = sprintf('median value  -> %g',median(dd));  disp(s);
    disp(' ');
    s = sprintf('missing value  -> %d samples',length(d)-length(dd));  disp(s);
    
else % atrybut nominalny
    s = sprintf('Attribute %d name: %s (nominal)', n, nazwa);
    disp(s); disp(' ');
    
    disp('Attribute values:');
    
    for i = 1:length(lista)
        s = sprintf('%s  -> %d samples',lista{i},sum(i==d));  disp(s);
    end
    
    disp(' ');
    s = sprintf('missing value  -> %d samples',sum(isnan(d)));  disp(s);
end
