% Funkcja wczytuje dane w formacie programu Weka, (c) mkorzen@wi.ps.pl 2007,
% zmiany: M.Plucinski
% 
% [result]=readArff(fname)
% 
% result{1} - macierz numeryczna zawierajca dane:
%              - dla danych nominalnych - indeksy do wartosci, ktore sa w result(2),
%              - dla danych numerycznych - wartosci,
%              - wartosci brakujace reprezentowane sa przez NaN
% result{2} - macierz unikalnych wartosci poszczegolnych atrybutow (pusta dla atrybutow ciaglych)
% result{3} - nazwy zmiennych
% result{4} - nazwa tablicy danych

function [result] = readArff(fname)

kk=0;
varnames = {};
varcount=0;
table ='';
A={};
PA={};
wiersze={};
now=0;

try
    [fid, message]=fopen(fname);
catch
    warning('File open error!');
    return
end

while 1
    tline = fgetl(fid);
    if ~ischar(tline) 
        break 
    end    
    if isempty(tline) 
        continue 
    end    
        switch tline(1)
            case '%'
                continue
            case '@'
                [command, R]=strtok(tline);
                if strcmpi(command,'@relation') 
                   table = strtok(R);
                   continue;
                end
                if  strcmpi(command,'@data')
                    now=1;
                    continue;
                end   
               
                if strcmpi(command,'@attribute') 
                    varcount = varcount +1;
                    [name, R]= strtok(R) ;
                    
                    [klamry] = cutstr(R, '{', '}');
                    %R=strrep(R,' ','');
                    %[klamry, R] = strtok(R)
                    varnames{varcount}=strrep(name,'''','');                  
                    %if ~strcmpi(strtrim(klamry),'real') && ...
                    %   ~strncmpi(strtrim(klamry),'integer',7) && ...
                    %   ~strncmpi(strtrim(klamry),'numeric',7)
                    if ~isempty(klamry) 
                    
                        %tmp = regexp(klamry, '\{([^\}]*)\}','tokens')
                        vals={};
                        %tmp= tmp{1};
                        
                        %tmp=tmp(2:end-1)
                        tmp=klamry;
                        tmp=strrep(tmp,'''','');
                        tmp=strrep(tmp,' ','');
                        R=tmp;
                        while true                            
                            [m, R] = strtok(R, ',') ;                           
                            if isempty(m)
                                break;
                            end
                            vals{end+1}=m;
                        end
                        PA{varcount}=vals;
                        varvals{varcount}=strrep(klamry,' ' ,'');
                    
                    else
                        PA{varcount}={};
                    end
                   
                end 
            otherwise
                if now
                    wiersze{end+1}=tline;
                end
                
        end
        kk=kk+1;
        if  tline(1)=='%'
        end
end

nn = length(wiersze);
A=cell(length(wiersze), varcount);
for ii=1:nn
    R= wiersze{ii};
    R=R(1:end);
    R=strrep(R,'''',''); 
    R=strrep(R,' ','');
    for jj=1:varcount
        [m, R]=strtok(R,',');
        if isempty(PA{jj})
            A{ii,jj}=str2double(m);
        else
            A{ii,jj}=m;
        end
    end
end
fclose(fid);

% A - macierz komrkowa zawierajca dane
% PA - macierz unikalnych wartosci poszczegolnych atrybutow
% varnames - nazwy zmiennych
% table - nazwa tablicy danych

r = { A PA varnames table };
D = c2Num(r);

result = { D PA varnames table };


% -------------------------------------------------------------------
% funkcja pomocnicza - wycina fragment stringa
function out = cutstr(str, left, right)
if nargin==2
    le=findstr(str,left)  
    if length(le)>=2
        'a'
        out=str(le(1)+1 : le(2)-1)
    else
        out = '';
    end
elseif nargin==3
    le=findstr(str,left);
    ri=findstr(str,right);
    if ~isempty(le) && ~isempty(ri)
        out=str(le(1)+size(left) : ri(1)-1);
    else
        out = '';
    end
end


% -------------------------------------------------------------------
% Tworzy z macierzy komrkowej A reprezentujcej dane nominalne, postac z macierz numeryczn D.
% Poprawnie dziaa take dla atrybutw numerycznych przenoszc po prostu ich wartoci z A do D.
% Nominalne wartoci zamieniane s na ich numery przechowywane w A{2}.
% Brakujce wartoci sa zamieniane z '?" na NaN.
function D = c2Num(A)

[ilProbek, ilAtr] = size(A{1});
D = zeros(size(A{1}));  % macierz wynikowa

for i = 1:ilAtr
     for j = 1:ilProbek
         if  isempty(A{2}{i}) 
             D(j,i) = A{1}{j,i};
         else
             if strcmp(A{1}{j,i},'?') 
                D(j,i) = NaN;
             else
                    k = strmatch(A{1}{j,i},  A{2}{i}, 'exact');
                    D(j,i) = k;
              end
          end
      end
end