% Funkcja zapisuje dane w formacie programu Weka
% 
% saveArff(fname, A)
%
% Parametry:  
%   fname - nazwa pliku (z rozszerzeniem .arff !!)
%   A - macierz komorkowa danych
% 
function [] = saveArff(fname, A)

id = fopen(fname,'w');

fprintf(id,'@RELATION %s \n\n',A{4});

for i=1:length(A{3})
    fprintf(id,'@ATTRIBUTE %-20s ',A{3}{i});
    lista = A{2}{i};
    if  isempty(lista) % atrybut numeryczny
        fprintf(id,' NUMERIC\n');
    else               % atrybut nominalny
        fprintf(id,' {');
        for j = 1:length(lista)
            fprintf(id,'%s',lista{j});
            if j < length(lista)
               fprintf(id,',');
            end
        end
        fprintf(id,'}\n');
    end
end

fprintf(id,'\n@DATA\n');
[ilProbek, ilAtr] = size(A{1});

for i = 1:ilProbek
    for j = 1:ilAtr
        if isnan(A{1}(i,j))
           fprintf(id,'?');
        else
           if isempty(A{2}{j})   % atrybut numeryczny
              fprintf(id,'%g',A{1}(i,j)); 
           else                  % atrybut nominalny
              fprintf(id,'%s',A{2}{j}{A{1}(i,j)});
           end
        end
        if j<ilAtr
           fprintf(id,',');            
        end
    end
    fprintf(id,'\n');
end

fclose(id);
